乐扣332 重新安排行程

问题描述
给定一个机票的字符串二维数组 [from, to],子数组中的两个成员分别表示飞机出发和降落的机场地点,对该行程进行重新规划排序。所有这些机票都属于一个从 JFK(肯尼迪国际机场)出发的先生,所以该行程必须从 JFK 开始。

说明:

如果存在多种有效的行程,你可以按字符自然排序返回最小的行程组合。例如,行程 [“JFK”, “LGA”] 与 [“JFK”, “LGB”] 相比就更小,排序更靠前

所有的机场都用三个大写字母表示(机场代码)。

假定所有机票至少存在一种合理的行程。

示例 1:

输入: [[“MUC”, “LHR”], [“JFK”, “MUC”], [“SFO”, “SJC”], [“LHR”, “SFO”]]

输出: [“JFK”, “MUC”, “LHR”, “SFO”, “SJC”]

示例 2:

输入: [[“JFK”,“SFO”],[“JFK”,“ATL”],[“SFO”,“ATL”],[“ATL”,“JFK”],[“ATL”,“SFO”]]

输出: [“JFK”,“ATL”,“JFK”,“SFO”,“ATL”,“SFO”]

解释: 另一种有效的行程是 [“JFK”,“SFO”,“ATL”,“JFK”,“ATL”,“SFO”]。但是它自然排序更大更靠后

思路:
1、(深度遍历+欧拉路径) 欧拉路径:每一条路都要遍历到
2、 此次的终点站当做下一站的起始站遍历,其中,在获取到达站后(即下一张机票的起始站),要在机票中删除该次车程,避免下一次遍历重复
3、相同的起始站放在一起,但会出现不同的终点站,所以:unordered_mapm来存放车票

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
class Solution {
     
public:
    vector<string>ans;
    unordered_map<string,multiset<string> >m;
    void dfs(string f){
     
        while(m[f].size()!=0){
     
            string to=*m[f].begin();
            m[f].erase(m[f].begin());
            dfs(to);
        }
        ans.push_back(f);
    }
    vector<string> findItinerary(vector<vector<string> > &tickets){
     
        for(auto &i:tickets)
            m[i[0]].insert(i[1]);
        dfs("JFK");
        reverse(ans.begin(),ans.end());
        return ans;
    }
};
int main()
{
     
    vector<vector<string> > tickets;
    int m;
    cin>>m;
    string a1,a2;
    for(int i=0; i<m; i++)
    {
     
        vector<string> aTicket;
        cin>>a1>>a2;
        aTicket.push_back(a1);
        aTicket.push_back(a2);
        tickets.push_back(aTicket);
    }
    vector<string> res=Solution().findItinerary(tickets);
    for(int i=0; i<res.size(); i++)
    {
     
        if (i>0)
            cout<<" ";
        cout<<res[i];
    }
    return 0;
}


你可能感兴趣的:(LeetCode)